'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

var _lodash = require('lodash.get');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.uniq');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.omit');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.pick');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.keys');

var _lodash10 = _interopRequireDefault(_lodash9);

var _lodash11 = require('lodash.assign');

var _lodash12 = _interopRequireDefault(_lodash11);

var _lodash13 = require('lodash.forown');

var _lodash14 = _interopRequireDefault(_lodash13);

var _lodash15 = require('lodash.toarray');

var _lodash16 = _interopRequireDefault(_lodash15);

var _lodash17 = require('lodash.isempty');

var _lodash18 = _interopRequireDefault(_lodash17);

var _lodash19 = require('lodash.flatten');

var _lodash20 = _interopRequireDefault(_lodash19);

var _DefaultElements = require('./DefaultElements');

var DefaultElements = _interopRequireWildcard(_DefaultElements);

var _lodash21 = require('lodash.startcase');

var _lodash22 = _interopRequireDefault(_lodash21);

var _lodash23 = require('lodash.defaultsdeep');

var _lodash24 = _interopRequireDefault(_lodash23);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Form = (_temp = _class = function (_Component) {
  _inherits(Form, _Component);

  function Form(props, _ref) {
    var config = _ref.joifulReactForms;

    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this, props));

    _this.state = {
      keyMap: {},
      schema: {}
    };

    _this.state = _extends({}, _this.state, _this.getStateFromProps(props));

    var _config = _extends({}, config);

    var Input = _config.Input;

    _this.elemTypes = _this.getElemTypes((0, _lodash2.default)(Input, 'types', {}));

    // Bind methods
    _this.getStateFromProps = _this.getStateFromProps.bind(_this);
    _this.getErrors = _this.getErrors.bind(_this);
    _this.submit = _this.submit.bind(_this);
    _this.getFormData = _this.getFormData.bind(_this);
    _this.getValue = _this.getValue.bind(_this);
    _this.getAllErrors = _this.getAllErrors.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.onFocus = _this.onFocus.bind(_this);
    _this.onBlur = _this.onBlur.bind(_this);
    return _this;
  }

  _createClass(Form, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        form: {
          schema: this.props.schema,
          getValue: this.getValue,
          getErrors: this.getErrors,
          onChange: this.onChange,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          elemTypes: this.elemTypes
        }
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState(this.getStateFromProps(this.props));
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref2, _ref3) {
      var elementTypes = _ref2.elementTypes;

      var props = _objectWithoutProperties(_ref2, ['elementTypes']);

      var config = _ref3.joifulReactForms;

      var _config2 = _extends({}, config);

      var Input = _config2.Input;

      this.elemTypes = this.getElemTypes((0, _lodash2.default)(Input, 'types', {}));
      this.setState(this.getStateFromProps(props));
    }
  }, {
    key: 'getElemTypes',
    value: function getElemTypes() {
      var elementTypes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      return _extends({
        text: DefaultElements.TextInput,
        select: function select() {},
        textarea: DefaultElements.Textarea,
        checkbox: DefaultElements.Checkbox
      }, elementTypes);
    }
  }, {
    key: 'setLabel',
    value: function setLabel() {
      var schema = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

      schema._settings = (0, _lodash24.default)((0, _lodash2.default)(schema, '_settings', {}), {
        language: {
          label: (0, _lodash22.default)(name)
        }
      });
      return schema;
    }
  }, {
    key: 'getStateFromProps',
    value: function getStateFromProps(props) {
      var _this2 = this;

      var state = _extends({}, this.state, {
        propErrors: props.errors,
        values: props.values
      });
      if (props.schema) {
        (0, _lodash14.default)(props.schema, function (schema, name) {
          state.schema[name] = schema;
          schema._joinedMetaData = _lodash12.default.apply(_this2, schema._meta) || {};
          schema._joinedMetaData.name = name;
          schema._tags = (0, _lodash4.default)((0, _lodash20.default)((0, _lodash16.default)(schema._tags).concat(name)));
          schema = _this2.setLabel(schema, name);
          state.keyMap[schema._settings.language.label] = name;
          state.values[name] = (0, _lodash2.default)(props, ['values', name]) || schema._flags.default;
          if (state.values[name] === undefined && schema._type === 'boolean') {
            state.values[name] = false;
          }
        });
      }
      return state;
    }
  }, {
    key: 'getErrors',
    value: function getErrors(fieldName) {
      var errors = _extends({}, this.state.errors, this.state.propErrors);
      if (fieldName && !(0, _lodash18.default)(errors)) {
        return errors[fieldName];
      }
      return null;
    }
  }, {
    key: 'parseJoiErrors',
    value: function parseJoiErrors(_ref4) {
      var details = _ref4.details;

      var errors = {};
      details.forEach(function (_ref5) {
        var path = _ref5.path;
        var message = _ref5.message;

        errors[path] = message;
      });
      return errors;
    }
  }, {
    key: 'submit',
    value: function submit(event) {
      var _this3 = this;

      if (!this.props.onSubmit) {
        return;
      }

      event.preventDefault();

      var onSubmit = this.props.onSubmit;
      var schema = this.state.schema;

      var values = this.getFormData(this.state.values);
      var options = _extends({}, this.props.options, {
        abortEarly: false,
        context: values
      });
      var errors = null;

      _joi2.default.validate(values, schema, options, function (err) {
        if (err) {
          errors = _this3.parseJoiErrors(err);
        }
      });

      this.setState({ errors: errors });
      onSubmit(errors, values, event);
    }
  }, {
    key: 'getFormData',
    value: function getFormData() {
      var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      return (0, _lodash8.default)(values, (0, _lodash10.default)(this.state.schema));
    }
  }, {
    key: 'getValue',
    value: function getValue(fieldName) {
      var values = this.state.values;

      if (fieldName && values) {
        return typeof values[fieldName] !== 'undefined' ? values[fieldName] : '';
      }
      return '';
    }
  }, {
    key: 'getAllErrors',
    value: function getAllErrors() {
      var errors = _extends({}, this.state.errors, this.state.propErrors);
      return (0, _lodash18.default)(errors) ? null : errors;
    }
  }, {
    key: 'onChange',
    value: function onChange(event, values) {
      var _this4 = this;

      var _event$target = event.target;
      var checked = _event$target.checked;
      var name = _event$target.name;
      var value = _event$target.value;


      var nextState = {
        values: _extends({}, this.state.values, values)
      };

      var schema = this.state.schema;


      _joi2.default.validate(nextState.values, schema, { abortEarly: false }, function (err) {
        if (err) {
          nextState.errors = _this4.parseJoiErrors(err);
        } else {
          nextState.errors = {};
        }
        _this4.setState(nextState);
      });

      var onChange = this.props.onChange;

      if (onChange) {
        onChange(event, nextState.values);
      }

      this.setState(nextState);
    }
  }, {
    key: 'onFocus',
    value: function onFocus(event) {
      var onFocus = this.props.onFocus;

      if (onFocus) {
        onFocus(event);
      }
    }
  }, {
    key: 'onBlur',
    value: function onBlur(event) {
      var _this5 = this;

      var _event$target2 = event.target;
      var name = _event$target2.name;
      var value = _event$target2.value;
      var schema = this.state.schema;


      if (this.props.onBlur && value.length === 0 && typeof value === 'string' && (0, _lodash2.default)(schema, '_flags.presence') !== 'required') {
        this.props.onBlur(event);
      }

      _joi2.default.validate(value, schema, { abortEarly: false }, function (err) {
        if (err) {
          _this5.setState({
            errors: _this5.parseJoiErrors(err)
          });
        } else {
          _this5.setState({
            errors: {}
          });
        }
      });

      if (this.props.onBlur) {
        this.props.onBlur(event);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;

      var props = _objectWithoutProperties(_props, ['children']);

      return _react2.default.createElement('form', _extends({}, (0, _lodash6.default)(props, 'schema', 'errors', 'options'), {
        onSubmit: this.submit,
        children: children || _react2.default.createElement(DefaultElements.DefaultInputGroup, null)
      }));
    }
  }]);

  return Form;
}(_react.Component), _class.contextTypes = {
  joifulReactForms: _react.PropTypes.object
}, _class.propTypes = {
  children: _react.PropTypes.node,
  elementTypes: _react.PropTypes.object,
  errors: _react.PropTypes.object,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func,
  onFocus: _react.PropTypes.func,
  onSubmit: _react.PropTypes.func,
  options: _react.PropTypes.object,
  schema: _react.PropTypes.object.isRequired,
  values: _react.PropTypes.object
}, _class.childContextTypes = {
  form: _react.PropTypes.object
}, _class.defaultProps = {
  errors: {},
  options: {},
  values: {}
}, _temp);
exports.default = Form;