'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _lodash = require('lodash.get');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = (_temp = _class = function (_Component) {
  _inherits(Input, _Component);

  function Input(props, context) {
    _classCallCheck(this, Input);

    // Bind methods
    var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props, context));

    _this.onChange = _this.onChange.bind(_this);
    _this.getSchema = _this.getSchema.bind(_this);
    _this.defaults = _this.defaults.bind(_this);
    _this.validateSchema = _this.validateSchema.bind(_this);
    return _this;
  }

  _createClass(Input, [{
    key: 'onChange',
    value: function onChange(event) {
      if (event.preventDefault) {
        event.preventDefault();
      }
      if (this.props.onChange) {
        this.props.onChange(event);
      }
      if (this.context.form.onChange) {
        this.context.form.onChange(event, _defineProperty({}, event.target.name, event.target.checked || event.target.value));
      }
    }
  }, {
    key: 'getSchema',
    value: function getSchema() {
      var form = this.context.form;

      if (!form || !form.schema) {
        return null;
      }
      var name = this.props.name;

      var schema = form.schema[name];
      if (!schema) {
        console.error(name + ' is not a key in your schema.');
      }
      return schema;
    }
  }, {
    key: 'optionsForSelectElem',
    value: function optionsForSelectElem() {
      var schema = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if ((0, _lodash2.default)(schema, '_valids._set', []).length === 0) {
        return false;
      }
      var optionValues = schema._joinedMetaData.names || schema._valids._set;
      var optionNames = schema._valids._set;
      return optionNames.map(function (children, i) {
        return {
          children: children,
          value: optionValues[i]
        };
      });
    }
  }, {
    key: 'defaults',
    value: function defaults(schema, is) {
      if (!schema) {
        return {};
      }
      var defaults = _extends({}, schema._joinedMetaData, {
        required: schema._flags.presence === 'required',
        label: schema._settings.language.label,
        placeholder: is === 'text' ? schema._examples[0] : null
      });
      var options = this.optionsForSelectElem(schema);
      if (options) {
        defaults.options = options;
      }
      return defaults;
    }
  }, {
    key: 'validateSchema',
    value: function validateSchema(schema, is, name) {
      if (!schema) {
        return 'Schema is required';
      }
      if (!schema.isJoi) {
        return '\n        ' + name + ' does not match the expected format as a Joi schmea object.\n        A ValidatedForm must be passed in a valid schema that follows\n        the format specified in the Readme.\n      ';
      }
      if (typeof is === 'string') {
        if (!(0, _lodash2.default)(this, ['context', 'form', 'elemTypes', is])) {
          return '\n          [JoifulReactForms Error] The requested input type of\n          ' + is + ' does not have a defined element type\n        ';
        }
        if (is === 'select' && (0, _lodash2.default)(schema, '_valids._set', []).length === 0) {
          return '\n          Warning! ' + name + ' is a select element but no valid params were provided.\n        ';
        }
      }
      return false;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var is = _props.is;

      var props = _objectWithoutProperties(_props, ['is']);

      var schema = this.getSchema();
      var name = (0, _lodash2.default)(schema, '_joinedMetaData.name');

      var invalidation = this.validateSchema(schema, is, name);
      if (invalidation) {
        console.error(invalidation);
      }

      var form = (0, _lodash2.default)(this.context, 'form', {});
      var el = typeof is === 'string' ? (0, _lodash2.default)(form, ['elemTypes', is], 'input') : is;
      var value = form.getValue && form.getValue(name);
      var error = form.getErrors && form.getErrors(name);

      return (0, _react.createElement)(el, _extends({}, this.defaults(schema, is), props, {
        error: error,
        onBlur: form.onBlur,
        onChange: this.onChange,
        onFocus: form.onFocus,
        value: value
      }));
    }
  }]);

  return Input;
}(_react.Component), _class.contextTypes = {
  form: _react.PropTypes.object.isRequired
}, _class.propTypes = {
  is: _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.string]),
  name: _react.PropTypes.string.isRequired,
  onChange: _react.PropTypes.func
}, _class.defaultProps = {
  is: 'text'
}, _temp);
exports.default = Input;